org.cpsolver.coursett.constraint

## Class InstructorConstraint

- java.lang.Object
- - org.cpsolver.ifs.model.Constraint<V,T>
  - - org.cpsolver.ifs.assignment.context.ConstraintWithContext<Lecture,Placement,InstructorConstraint.InstructorConstraintContext>
    - - org.cpsolver.coursett.constraint.InstructorConstraint

- All Implemented Interfaces:
    Comparable<Constraint<Lecture,Placement>>, CanHoldContext, HasAssignmentContext<Lecture,Placement,InstructorConstraint.InstructorConstraintContext>
  Direct Known Subclasses:
    SoftInstructorConstraint

      public class InstructorConstraint
      extends ConstraintWithContext<Lecture,Placement,InstructorConstraint.InstructorConstraintContext>

  Instructor constraint.
  Classes with this instructor can not overlap in time. Also, for back-to-back classes, there is the following reasoning:
  - if the distance is equal or below `DistanceMetric.getInstructorNoPreferenceLimit()` .. no preference
  - if the distance is above `DistanceMetric.getInstructorNoPreferenceLimit()` and below `DistanceMetric.getInstructorDiscouragedLimit()` .. constraint is discouraged (soft, preference = 1)
  - if the distance is above `DistanceMetric.getInstructorDiscouragedLimit()` and below `DistanceMetric.getInstructorProhibitedLimit()` .. constraint is strongly discouraged (soft, preference = 2)
  - if the distance is above `DistanceMetric.getInstructorProhibitedLimit()` .. constraint is prohibited (hard)
  When `isIgnoreDistances()` is set to true, the constraint never prohibits two back-to-back classes (but it still tries to minimize the above back-to-back preferences).
  Version:
    CourseTT 1.3 (University Course Timetabling)
    Copyright (C) 2006 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `class` | `InstructorConstraint.InstructorConstraintContext`

  - ### Field Summary

    - ### Fields inherited from class org.cpsolver.ifs.model.Constraint

      `iConstraintListeners, iId`

    - ### Fields inherited from interface org.cpsolver.ifs.assignment.context.CanHoldContext

      `sMaxSize`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `InstructorConstraint(Long id, String puid, String name, boolean ignDist)` Constructor

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `computeConflicts(Assignment<Lecture,Placement> assignment, Placement placement, Set<Placement> conflicts)` The only method which has to be implemented by any constraint.
    `InstructorConstraint.InstructorConstraintContext` | `createAssignmentContext(Assignment<Lecture,Placement> assignment)` Create a new assignment context for the given assignment.
    `List<Placement>[]` | `getAvailableArray()` Deprecated.
    `protected DistanceMetric` | `getDistanceMetric()`
    `int` | `getDistancePreference(Placement p1, Placement p2)` Back-to-back preference of two placements (3 means prohibited)
    `String` | `getName()` Resource name
    `int` | `getPreference(Assignment<Lecture,Placement> assignment)`
    `int` | `getPreference(Assignment<Lecture,Placement> assignment, Placement value)` Back-to-back preference of the given placement
    `int` | `getPreferenceCombination(Assignment<Lecture,Placement> assignment, Placement value)`
    `String` | `getPuid()`
    `Long` | `getResourceId()` Resource id
    `Long` | `getType()`
    `List<Placement>` | `getUnavailabilities()`
    `int` | `getWorstPreference()` Worst back-to-back preference of this instructor
    `boolean` | `inConflict(Assignment<Lecture,Placement> assignment, Placement placement)` Returns true if the given assignment is inconsistent with the existing assignments respecting this constraint.
    `boolean` | `isAvailable(Lecture lecture, Placement placement)`
    `boolean` | `isAvailable(Lecture lecture, TimeLocation time)`
    `boolean` | `isConsistent(Placement p1, Placement p2)` Returns true if the given assignments are consistent respecting this constraint.
    `boolean` | `isIgnoreDistances()`
    `void` | `setIgnoreDistances(boolean ignDist)`
    `void` | `setNotAvailable(Placement placement)`
    `void` | `setType(Long type)`
    `String` | `toString()`

    - ### Methods inherited from class org.cpsolver.ifs.assignment.context.ConstraintWithContext

      `assigned, getAssignmentContextReference, getContext, getContext, setAssignmentContextReference, setModel, unassigned`

    - ### Methods inherited from class org.cpsolver.ifs.model.Constraint

      `addConstraintListener, addVariable, assignedVariables, compareTo, computeConflictsNoForwardCheck, constraintListeners, countAssignedVariables, countVariables, equals, getDescription, getId, getModel, hashCode, isHard, removeConstraintListener, removeVariable, variables`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### InstructorConstraint

          public InstructorConstraint(Long id,
                                      String puid,
                                      String name,
                                      boolean ignDist)

      Constructor
      Parameters:
        `id` - instructor id
        `puid` - instructor external id
        `name` - instructor name
        `ignDist` - true if distance conflicts are to be ignored

  - ### Method Detail

    - #### setNotAvailable

          public void setNotAvailable(Placement placement)

    - #### isAvailable

          public boolean isAvailable(Lecture lecture,
                                     TimeLocation time)

    - #### getDistanceMetric

          protected DistanceMetric getDistanceMetric()

    - #### isAvailable

          public boolean isAvailable(Lecture lecture,
                                     Placement placement)

    - #### getUnavailabilities

          public List<Placement> getUnavailabilities()

    - #### getAvailableArray

          @Deprecated
          public List<Placement>[] getAvailableArray()

      Deprecated.

    - #### getDistancePreference

          public int getDistancePreference(Placement p1,
                                           Placement p2)

      Back-to-back preference of two placements (3 means prohibited)
      Parameters:
        `p1` - first placement
        `p2` - second placement
      Returns:
        distance preference between the two placements

    - #### getResourceId

          public Long getResourceId()

      Resource id
      Returns:
        instructor unique id

    - #### getName

          public String getName()

      Resource name
      Overrides:
        `getName` in class `Constraint<Lecture,Placement>`
      Returns:
        constraint name

    - #### computeConflicts

          public void computeConflicts(Assignment<Lecture,Placement> assignment,
                                       Placement placement,
                                       Set<Placement> conflicts)

      Description copied from class: `Constraint`
      The only method which has to be implemented by any constraint. It returns the values which needs to be unassigned in order to make this constraint consistent with the given value if it is assigned to its variable. The computed list of conflicting values is added to the given set of conflicts.
      Specified by:
        `computeConflicts` in class `Constraint<Lecture,Placement>`
      Parameters:
        `assignment` - current assignment
        `placement` - value to be assigned to its variable
        `conflicts` - resultant set of conflicting values

    - #### inConflict

          public boolean inConflict(Assignment<Lecture,Placement> assignment,
                                    Placement placement)

      Description copied from class: `Constraint`
      Returns true if the given assignment is inconsistent with the existing assignments respecting this constraint. This method is used by MAC (see `MacPropagation`).
      Overrides:
        `inConflict` in class `Constraint<Lecture,Placement>`
      Parameters:
        `assignment` - current assignment
        `placement` - given value
      Returns:
        true if there is a conflict with other assigned variables of the constraint

    - #### isConsistent

          public boolean isConsistent(Placement p1,
                                      Placement p2)

      Description copied from class: `Constraint`
      Returns true if the given assignments are consistent respecting this constraint. This method is used by MAC (see `MacPropagation`).
      Overrides:
        `isConsistent` in class `Constraint<Lecture,Placement>`
      Parameters:
        `p1` - a value
        `p2` - a value
      Returns:
        true if the constraint is ok with the assignment

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### getPreference

          public int getPreference(Assignment<Lecture,Placement> assignment,
                                   Placement value)

      Back-to-back preference of the given placement
      Parameters:
        `assignment` - current assignment
        `value` - placement under consideration
      Returns:
        distance preference for the given placement

    - #### getPreference

          public int getPreference(Assignment<Lecture,Placement> assignment)

    - #### getPreferenceCombination

          public int getPreferenceCombination(Assignment<Lecture,Placement> assignment,
                                              Placement value)

    - #### getWorstPreference

          public int getWorstPreference()

      Worst back-to-back preference of this instructor
      Returns:
        worst possible distance preference

    - #### getPuid

          public String getPuid()

    - #### isIgnoreDistances

          public boolean isIgnoreDistances()

    - #### setIgnoreDistances

          public void setIgnoreDistances(boolean ignDist)

    - #### getType

          public Long getType()

    - #### setType

          public void setType(Long type)

    - #### createAssignmentContext

          public InstructorConstraint.InstructorConstraintContext createAssignmentContext(Assignment<Lecture,Placement> assignment)

      Description copied from interface: `HasAssignmentContext`
      Create a new assignment context for the given assignment. If there are already some variables assigned in the value, the method should make sure that the context is appropriately initialized.
      Parameters:
        `assignment` - an assignment for which there needs to be an assignment context
      Returns:
        a new instance of the assignment context, filled according to the given assignment